<?php
/**
* 123kurier - POPUP OKNO - zde se děje veškerý import apod.
*/


ob_start();

// tento skript má umožněn přímý přístup
require_once __DIR__.'/../../../wp-load.php';

$current_user = wp_get_current_user();
if (!$current_user->ID) {
	// UŽIVATEL MUSÍ BÝT PŘIHLÁŠEN V ADMINU
    die('Nejste přihlášen v administraci!');
}
else {
	// zkontrolujeme administrační práva
	$ok = false;
	foreach ($current_user->allcaps as $k => $is) {
		if (preg_match('~(_woocommerce|_orders)~', $k) && $is) {
			$ok = true;
		}
	}
	if (!$ok) {
		die('Nemáte dostatečná práva.');
	}
}
//------------------------------


include_once __DIR__.'/functions.php';


if (!isset($_GET['action'])) $_GET['action'] = '';
if (!isset($_GET['post_ids'])) $_GET['post_ids'] = '';

$post_ids = explode(',', trim($_GET['post_ids'], ', '));

foreach ($post_ids as $i => $id) {
	if (!is_numeric($id)) unset($post_ids[$i]);
}



/**
* Vrátí nejbližší možné svozové datum
*/
function zk123_soonestPickup($startDate = null)
{
	// svátky
	$holidayDays = ['1.1.','1.5.','8.5.','5.7.','6.7.','28.9.','28.10.','17.11.','24.12.','25.12.','26.12.'];
	
	$ts = current_time('timestamp');
	
	if (empty($startDate)) $startDate = $ts;
	if (!is_numeric($startDate)) $startDate = strtotime($startDate);
	
	$soonestTime = zk123_getConfig('pickup_time_today') ?: '17:00';
	
	$j = 0;
	do {
		$dayOrd = date("N", $startDate); // 1=Monday, 7=Sunday
		
		// je to dneska a přitom už se to nestíhá objednat
		if (date("Ymd", $startDate) == date("Ymd", $ts) && date("H:i", $ts) > $soonestTime);
		
		// nesmí být svátek
		elseif (in_array(date("d.m.", $startDate), $holidayDays) );
		
		// nesmí být sobota ani neděle
		elseif ($dayOrd == 6 || $dayOrd == 7);
		
		else
			break; // vše ok
		
		if ($j++ > 30) break; // nějaká chyba
	}
	while ($startDate+= 24*3600); // posuneme na další den
	
	return date("Y-m-d", $startDate);
}


/**
* BLOK pro výběr svozového data
*
* @param (string) $heading
* @param (array) $dates2highlight - dates[Y-m-d] = Y-m-d
*/
function zk123_chooseDate($heading, $dates2highlight = null) {
	?>
	<div class="text-center pt-4">
	<form method="post">
	<?php
	foreach ($_POST as $k => $v) echo '<input type="hidden" name="'.$k.'" value="'.htmlspecialchars($v).'">';
	?>
	<p><?= $heading ?></p>
	<?php
	//$days = array('Pondělí', 'Úterý', 'Středa', 'Čtvrtek', 'Pátek', 'Sobota', 'Neděle'); // nebudu řešit locale
	$days = array('Pondelok', 'Utorok', 'Streda', 'Štvrtok', 'Piatok', 'Sobota', 'Nedeľa');
	
	$printed = array();
	$i = 0;
	do {
		$Ymd = zk123_soonestPickup( strtotime('+'.$i.' days') );
		$i++;
		if (isset($printed[$Ymd])) continue;
		$printed[$Ymd] = $Ymd;
	}
	while (count($printed) < 10);
	
	if (is_array($dates2highlight)) {
		$printed = $dates2highlight;
		$printed = array_unique($printed);
		ksort($printed);
		
		echo '<p><button type="submit" name="pickup_date" value="" class="btn btn-secondary col-8">Chcem podať všetky označené zásielky</button></p>';
	}
	
	$first = true;
	foreach ($printed as $Ymd) {
		$isBig = (!isset($dates2highlight) && $first) || isset($dates2highlight[$Ymd]);
		$first = false;
		$dayname = $days[ date("N", strtotime($Ymd)) -1 ];
		echo '<p><button type="submit" name="pickup_date" value="'.$Ymd.'" class="btn btn-secondary col-'.($isBig ? 8 : 6).'">'.$dayname.'&nbsp; '.date("d. m. Y", strtotime($Ymd)).'</button></p>';
	}
	?>
	</form>
	</div>
	<?php
}


/**
* BLOK pro výběr IBAN účtu
*
* @param (string) $heading
*/
function zk123_chooseIban($heading, $ibans) {
	?>
	<div class="text-center pt-4">
	<form method="post">
	<?php
	foreach ($_POST as $k => $v) echo '<input type="hidden" name="'.$k.'" value="'.htmlspecialchars($v).'">';
	?>
	<p><?= $heading ?></p>
	<?php
	foreach ($ibans as $ibanArray) {
		[$iban, $name] = $ibanArray;
		echo '<p><button type="submit" name="iban" value="'.$iban.'" class="btn btn-secondary col-6"><b>'.$name.'</b><br><small>'.$iban.'</small></button></p>';
	}
	?>
	</form>
	</div>
	<?php
}

	
	

/**
* JSON AKCE
*/
if (!empty($_GET['action_json']))
{
	while(@ob_get_clean()); // pro jistotu
	header("Content-type: application/json; charset=utf-8");
	
	$post_id = intval($_GET['post_id']);
	
	$canUpdate = !zk123_getTrackingCodes($post_id);
	
	$ret = array();
	
	/**
	* ULOŽENÍ HMOTNOSTI U JEDNOHO BALÍKU (AJAX)
	*/
	if ($_GET['action_json'] == 'save_weight')
	{
		// ošetříme hmotnosti
		$str = $_GET['weight'];
		$str = str_replace('a', '+', $str);
		
		$weights = array();
		foreach (explode("+", $str) as $weight) {
			$weight = preg_replace('~[^0-9\.,+]~', '', $weight);
			$weight = str_replace('.', ',', $weight);
			$weight = trim($weight, ' ,');
			if (preg_match('~^([1-9]|0,)~', $weight)) {
				$weights[] = $weight;
			}
		}
		$weights = (string) implode('+', $weights);
		
		if ($canUpdate) {
			update_post_meta($post_id, '_zk123_packages_weight', $weights);
		} else {
			$weights = get_post_meta($post_id, '_zk123_packages_weight', true);
		}
		
		$ret['weight'] = $weights;
	}
	/**
	* ULOŽENÍ POZNÁMKY U ŘIDIČE U JEDNOHO BALÍKU (AJAX)
	*/
	elseif ($_GET['action_json'] == 'save_driver_note')
	{
		$str = trim($_GET['driver_note']);
		$str = preg_replace('["\']', '', $str); // pro jistotu
		
		if ($canUpdate) {
			update_post_meta($post_id, '_zk123_driver_note', $str);
		} else {
			$str = get_post_meta($post_id, '_zk123_driver_note', true);
		}
		
		$ret['driver_note'] = $str;
	}
	
	echo json_encode($ret);
	exit;
}


###############################################################

/**
* Chyba
*/
function zk123_error($str) {
	echo '<div class="alert alert-danger" role="alert">'.$str.'</div>';
}
/**
* OK
*/
function zk123_ok($str) {
	echo '<div class="alert alert-success">'.$str.'</div>';
}



/**
* HTML HEADING
*/
function heading($s = '')
{
	echo '<!doctype html>
	<html lang="cs">
	<head>
	<meta charset="utf-8">
	<meta http-equiv="X-UA-Compatible" content="IE=edge">
	<meta name="viewport" content="width=device-width, initial-scale=1">
	<title>123kuriér - '.$s.'</title>
	<link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.3.1/css/bootstrap.min.css" crossorigin="anonymous">
	<link rel="stylesheet" href="https://use.fontawesome.com/releases/v5.8.2/css/all.css" integrity="sha384-oS3vJWv+0UjzBfQzYUhtDYW+Pj2yciDJxpsK1OYPAYjqT085Qq/1cq5FLXAZQ7Ay" crossorigin="anonymous">
	<!--[if lt IE 9]>
	<script src="https://oss.maxcdn.com/html5shiv/3.7.3/html5shiv.min.js"></script>
	<script src="https://oss.maxcdn.com/respond/1.4.2/respond.min.js"></script>
	<![endif]-->
	<script src="https://code.jquery.com/jquery-3.4.1.min.js" integrity="sha256-CSXorXvZcTkaix6Yvo6HppcZGetbYMGWSFlBw8HfCJo=" crossorigin="anonymous"></script>
	<script src="https://stackpath.bootstrapcdn.com/bootstrap/4.3.1/js/bootstrap.bundle.min.js" crossorigin="anonymous"></script>
	<style>
	HEADER{
		box-shadow: 0 0 5px 2px rgba(0,0,0,.3);
		background: #eee;
		border-bottom: 2px solid #47484C;
		text-align: center;
		padding-top: 5px;
	}
	HEADER SPAN{
		vertical-align: middle;
		display: inline-block;
		margin-left: 21px;
		padding-left: 18px;
		border-left: 1px solid #E37750;
		line-height: 1.4;
		font-weight: bold;
		padding-top: 6px;
		padding-bottom: 6px;
	}
	.form-group {
		margin-bottom: 1.25rem;
	}
	.form-group.row{
			margin-bottom: 0.3rem;
	}
	.form-group LABEL{
		font-weight:bold;
		color:#444;
	}
	.form-checks-inline .form-check{
		display: inline-block;
		border: 1px solid #ccc;
		border-radius: 5px;
		padding: 7px 7px 7px 1.7rem;
		line-height: 20px;
		cursor:pointer;
	}
	.form-checks-inline .form-check:hover{
		background:#eee;
	}
	.form-checks-inline .form-check LABEL:hover{
		background:initial;
	}
	.form-check{
		line-height: 19px;
		padding-top: 5px;
		padding-bottom: 5px;
		padding-left:1.5rem;
	}
	.form-check INPUT{
		cursor:pointer;
	}
	.form-check LABEL{
		font-weight:normal;
		cursor:pointer;
	}
	.form-check LABEL:hover {
		background: #eee;
	}
	.form-check-input.mytoggl:checked + LABEL{
		font-weight:Bold;
	}
	.form-check-input:checked + LABEL{
		color:#0033cc;
	}
	</style>
	<link rel="shortcut icon" href="favicon.ico" type="image/x-icon" />
	</head>
	<body>';

	echo '<header><h1 class="h4 p-2"><img src="logo.png" width="176" height="52" alt="123kuriér"><span>'.$s.'</span></h1></header><main class="py-3 px-1"><div class="container-fluid">';	
}

/**
* HTML FOOTER
*/
function footer() {
	echo '</div></main>';
	echo '</body></html>';
}


##################################################

if ($_GET['action'] == 'configuration')
{
	//---- HLAVNÍ KONFIGURACE
	heading("Konfigurácia");
	
	
	if ($_POST)
	{
		// uložíme konfiguraci
		
		$keys = array(
			'pickup_on', 'iban', 'sender_on', 'extra_insurance', 'extra_gdd', 'extra_d12', 'extra_sAdvice', 'extra_tAdvice'
		);
		foreach ($keys as $k) {
			if (!isset($_POST[$k])) $_POST[$k] = ''; // E_NOTICE
		}
		
		zk123_setConfig('username', trim($_POST['username']));
		zk123_setConfig('gpsw', trim($_POST['gpsw']));
		zk123_setConfig('shipping_regexp', trim($_POST['shipping_regexp']));
		zk123_setConfig('cod_regexp', trim($_POST['cod_regexp']));
		zk123_setConfig('id_sender', trim($_POST['id_sender']));
		zk123_setConfig('label_type', trim($_POST['label_type']));
		
		zk123_setConfig('pickup_on', trim($_POST['pickup_on']));
		zk123_setConfig('pickup_name', trim($_POST['pickup_name']));
		zk123_setConfig('pickup_street', trim($_POST['pickup_street']));
		zk123_setConfig('pickup_zip', trim($_POST['pickup_zip']));
		zk123_setConfig('pickup_city', trim($_POST['pickup_city']));
		zk123_setConfig('pickup_phone', trim($_POST['pickup_phone']));
		zk123_setConfig('pickup_email', trim($_POST['pickup_email']));
		
		zk123_setConfig('sender_on', trim($_POST['sender_on']));
		zk123_setConfig('sender_name', trim($_POST['sender_name']));
		zk123_setConfig('sender_street', trim($_POST['sender_street']));
		zk123_setConfig('sender_city', trim($_POST['sender_city']));
		zk123_setConfig('sender_zip', trim($_POST['sender_zip']));
		
		zk123_setConfig('extra_insurance', !!$_POST['extra_insurance']);
		zk123_setConfig('extra_gdd', !!$_POST['extra_gdd']);
		zk123_setConfig('extra_d12', !!$_POST['extra_d12']);
		zk123_setConfig('extra_sAdvice', !!$_POST['extra_sAdvice']);
		zk123_setConfig('extra_tAdvice', !!$_POST['extra_tAdvice']);
		
		zk123_setConfig('default_weight', $_POST['default_weight']);
		
		
		zk123_setConfig('places_SK', isset($_POST['places_SK']));
		zk123_setConfig('places_SK_BOX', isset($_POST['places_SK_BOX']));
		zk123_setConfig('places_CZ', isset($_POST['places_CZ']));
		zk123_setConfig('places_CZ_BOX', isset($_POST['places_CZ_BOX']));
		
		zk123_setConfig('big_packages_only', isset($_POST['big_packages_only']));
		
		
		$ptt = trim($_POST['pickup_time_today']);
		if (!preg_match('~^\d+:\d+$~', $ptt)) {
			$ptt = '';
		}
		zk123_setConfig('pickup_time_today', $ptt);
		
		
		zk123_setConfig('iban', trim($_POST['iban']));
		
		$j = 2;
		if (isset($_POST['multiple_ibans'])) {
			for ($i=2; $i<=9; $i++) {
				$iban = trim($_POST['iban'.$i]);
				if ($j == 2 && empty(trim($_POST['iban']))) {
					// uložíme jako hlavní IBAN
					zk123_setConfig('iban', $iban);
					$_POST['iban'] = $iban;
				} elseif (!empty($iban)) {
					zk123_setConfig('iban'.$j, $iban);
					zk123_setConfig('iban_name'.$j, $_POST['iban_name'.$i]);
					$j++;
				}
			}
		}
		for ($j; $j<=9; $j++) {
			zk123_setConfig('iban'.$j, '');
		}
		
		
		
		zk123_ok('<div class="text-center font-weight-bold msgok">Konfigurácia bola uložená &#128578;</div>');
	}
	?>
	<form method="post">
	
		<div class="form-group mb-3">
			<!-- <p><small class="form-text text-muted">Prístupy sú vygenerované samostatne na žiadosť.</small></p> -->
			<label for="username">API užívateľské meno:</label>
			<input type="text" class="form-control" id="username" name="username" value="<?= esc_attr(zk123_getConfig('username')); ?>">
		</div>
		<div class="form-group mb-3">
			<label for="gpsw">API heslo:</label>
			<input type="text" class="form-control" id="gpsw" name="gpsw" value="<?= esc_attr(zk123_getConfig('gpsw')); ?>">
		</div>
		<div class="form-group mb-3">
			<label for="id_sender">ID adresy odosielateľa:</label>
			<input type="text" class="form-control" id="id_sender" name="id_sender" value="<?= esc_attr(zk123_getConfig('id_sender')); ?>">
			<small class="form-text text-muted">
				<p>ID pridelí 123kuriér, je jedinečné pre každého zákazníka.</p>
			</small>
		</div>
		
		<div class="form-group form-check mb-3">
			<input type="checkbox" class="form-check-input mytoggl" id="checkPickup" name="pickup_on" value="1"<?= zk123_getConfig('pickup_on') ? ' checked' : ''; ?>>
			<label class="form-check-label" for="checkPickup">Iná adresa pre zvoz (nepovinné)</label>
		</div>
		
		<div class="form-group" data-id="checkPickup">
			<div>
				<div class="form-group row">
					<label class="col-3 text-right align-self-center my-0" for="pickup_name">Meno:</label>
					<div class="col-9 pl-0">
						<input type="text" class="form-control" id="pickup_name" name="pickup_name" value="<?= zk123_getConfig('pickup_name'); ?>">
					</div>
				</div>
				<div class="form-group row">
					<label class="col-3 text-right align-self-center my-0" for="pickup_street">Ulica:</label>
					<div class="col-9 pl-0">
						<input type="text" class="form-control" id="pickup_street" name="pickup_street" value="<?= zk123_getConfig('pickup_street'); ?>">
					</div>
				</div>
				<div class="form-group row">
					<label class="col-3 text-right align-self-center my-0" for="pickup_zip">PSČ:</label>
					<div class="col-9 pl-0">
						<input type="text" class="form-control" id="pickup_zip" name="pickup_zip" pattern="^[0-9]{5}$" value="<?= zk123_getConfig('pickup_zip'); ?>">
					</div>
				</div>
				<div class="form-group row">
					<label class="col-3 text-right align-self-center my-0" for="pickup_city">Mesto:</label>
					<div class="col-9 pl-0">
						<input type="text" class="form-control" id="pickup_city" name="pickup_city" value="<?= zk123_getConfig('pickup_city'); ?>">
					</div>
				</div>
				<div class="form-group row">
					<label class="col-3 text-right align-self-center my-0" for="pickup_phone">Telefón:</label>
					<div class="col-9 pl-0">
						<input type="text" class="form-control" id="pickup_phone" name="pickup_phone" value="<?= zk123_getConfig('pickup_phone'); ?>">
					</div>
				</div>
				<div class="form-group row">
					<label class="col-3 text-right align-self-center my-0" for="pickup_phone">Email:</label>
					<div class="col-9 pl-0">
						<input type="text" class="form-control" id="pickup_email" name="pickup_email" value="<?= zk123_getConfig('pickup_email'); ?>">
					</div>
				</div>
			</div>
		</div>
		
		<div class="form-group form-check">
			<input type="checkbox" class="form-check-input mytoggl" id="checkSender" name="sender_on" value="1"<?= zk123_getConfig('sender_on') ? ' checked' : ''; ?>>
			<label class="form-check-label" for="checkSender">Krycia adresa odosielateľa (nepovinné)</label>
		</div>
		
		<div class="form-group" data-id="checkSender">
			<div>
				<div class="form-group row">
					<label class="col-3 text-right align-self-center my-0" for="sender_name">Meno:</label>
					<div class="col-9 pl-0">
						<input type="text" class="form-control" id="sender_name" name="sender_name" value="<?= zk123_getConfig('sender_name'); ?>">
					</div>
				</div>
				<div class="form-group row">
					<label class="col-3 text-right align-self-center my-0" for="sender_street">Ulica:</label>
					<div class="col-9 pl-0">
						<input type="text" class="form-control" id="sender_street" name="sender_street" value="<?= zk123_getConfig('sender_street'); ?>">
					</div>
				</div>
				<div class="form-group row">
					<label class="col-3 text-right align-self-center my-0" for="sender_zip">PSČ:</label>
					<div class="col-9 pl-0">
						<input type="text" class="form-control" id="sender_zip" name="sender_zip" pattern="^[0-9]{5}$" value="<?= zk123_getConfig('sender_zip'); ?>">
					</div>
				</div>
				<div class="form-group row">
					<label class="col-3 text-right align-self-center my-0" for="sender_city">Mesto:</label>
					<div class="col-9 pl-0">
						<input type="text" class="form-control" id="sender_city" name="sender_city" value="<?= zk123_getConfig('sender_city'); ?>">
					</div>
				</div>
			</div>
		</div>
		
		<hr>
		
		
		<div class="form-group mb-3">
			<label>Povolené pobočky:</label>
			
			<div class="form-checks-inline">
				<div class="form-check">
				<input type="checkbox" class="form-check-input" value="1" name="places_SK" id="places_SK"<?= zk123_getConfig('places_SK') ? ' checked' : ''; ?>>
				<label class="form-check-label" for="places_SK">SK</label>
				</div>
				
				<div class="form-check">
				<input type="checkbox" class="form-check-input" value="1" name="places_SK_BOX" id="places_SK_BOX"<?= zk123_getConfig('places_SK_BOX') ? ' checked' : ''; ?>>
				<label class="form-check-label" for="places_SK_BOX">SK BOX</label>
				</div>
				
				<div class="form-check">
				<input type="checkbox" class="form-check-input" value="1" name="places_CZ" id="places_CZ"<?= zk123_getConfig('places_CZ') ? ' checked' : ''; ?>>
				<label class="form-check-label" for="places_CZ">CZ</label>
				</div>
				
				<div class="form-check">
				<input type="checkbox" class="form-check-input" value="1" name="places_CZ_BOX" id="places_CZ_BOX"<?= zk123_getConfig('places_CZ_BOX') ? ' checked' : ''; ?>>
				<label class="form-check-label" for="places_CZ_BOX">CZ BOX</label>
				</div>
			</div>
		</div>
		
		<div class="form-group form-check">
			<input type="checkbox" class="form-check-input mytoggl" value="1" name="big_packages_only" id="big_packages_only"<?= zk123_getConfig('big_packages_only') ? ' checked' : ''; ?>>
			<label class="form-check-label" for="big_packages_only">Zobrazovať výlučne pobočky, ktoré podporujú XXL balíky.</label>
		</div>
		
		
		
		<div class="form-group">
			<label for="shipping_regexp">Názov dopravy pre aktiváciu pluginu:</label>
			<input type="text" class="form-control" id="shipping_regexp" name="shipping_regexp" style="font-family:Monospace,Courier New;" value="<?= esc_attr(zk123_getConfig('shipping_regexp')); ?>" placeholder="">
			<small class="form-text text-muted">
				<p>Panel 123KURIÉR sa zobrazí ak doprava u objednávky bude obsahovať jeden z týchto reťazcov.<br>Pokiaľ necháte prázdne, bude sa panel ukazovať vždy.</p>
			</small>
		</div>
		
		<div class="form-group">
			<label for="cod_regexp">Názov platby v prípade dobierky:</label>
			<input type="text" class="form-control" id="cod_regexp" name="cod_regexp" style="font-family:Monospace,Courier New;" value="<?= esc_attr(zk123_getConfig('cod_regexp')); ?>" placeholder="" required>
			<small class="form-text text-muted">
				<p>Ak názov platby bude u objednávky obsahovať jeden z týchto reťazcov, použije sa pri importe balíka dobierka.<br>Predvolené sú tieto slová: dobierka, dobierku, dobierkou, pri prevzatí, v hotovosti.<br>Ak necháte prázdne použije sa dobierka vždy.</p>
			</small>
		</div>
		
		
		<hr>
		
		<div class="form-group mb-3">
			<label for="iban">IBAN číslo účtu:</label>
			<input type="text" class="form-control" id="iban" name="iban" value="<?= esc_attr(zk123_getConfig('iban')); ?>" placeholder="SK">
			<small class="form-text text-muted">
				<p>Číslo účtu pre dobierku. Len pre zásielky doručované na SK.</p>
			</small>
		</div>
		
		<?php
		$multipleIbans = false;
		for ($i=2; $i<=9; $i++) {
			if (!empty(zk123_getConfig('iban'.$i))) $multipleIbans = true;
		}
		?>
		<div class="form-group form-check">
			<input type="checkbox" class="form-check-input mytoggl" value="1" name="multiple_ibans" id="multiple_ibans"<?= $multipleIbans ? ' checked' : ''; ?>>
			<label class="form-check-label" for="multiple_ibans">Mám ďalšie bankové účty a budem si vyberať podľa potreby</label>
		</div>
		
		<div class="form-group" data-id="multiple_ibans">
			<div>
				<div class="form-group row font-weight-bold">
					<div class="col-8 pr-1">Ďalšie IBAN číslo účtu</div>
					<div class="col-4 pl-0">Pomenovanie</div>
				</div>
				<?php for ($i=2; $i<=9; $i++) { ?>
				<div class="form-group row">
					<div class="col-8 pr-1">
						<input type="text" class="form-control" name="iban<?= $i ?>" value="<?= zk123_getConfig('iban'.$i); ?>" placeholder="SK">
					</div>
					<div class="col-4 pl-0" for="iban<?= $i ?>">
						<input type="text" class="form-control" style="color:purple" name="iban_name<?= $i ?>" value="<?= zk123_getConfig('iban_name'.$i); ?>" placeholder="IBAN č. <?= $i ?>">
					</div>
				</div>
				<?php } ?>
			</div>
		</div>
		
		<hr>
		
		<div class="form-group">
			<label>Extra služby:</label>
			
			<div class="form-check">
			<input type="checkbox" class="form-check-input" value="1" name="extra_insurance" id="extra_insurance"<?= zk123_getConfig('extra_insurance') ? ' checked' : ''; ?>>
			<label class="form-check-label" for="extra_insurance">Poistenie balíka</label>
			</div>
			
			<div class="form-check">
			<input type="checkbox" class="form-check-input" value="1" name="extra_gdd" id="extra_gdd"<?= zk123_getConfig('extra_gdd') ? ' checked' : ''; ?>>
			<label class="form-check-label" for="extra_gdd">Garantované doručenie (len CZ/SK)</label>
			</div>
			
			<div class="form-check">
			<input type="checkbox" class="form-check-input" value="1" name="extra_d12" id="extra_d12"<?= zk123_getConfig('extra_d12') ? ' checked' : ''; ?>>
			<label class="form-check-label" for="extra_d12">Doručenie do 12h (len CZ/SK)</label>
			</div>
			
			<div class="form-check">
			<input type="checkbox" class="form-check-input" value="1" name="extra_sAdvice" id="extra_sAdvice"<?= zk123_getConfig('extra_sAdvice') ? ' checked' : ''; ?>>
			<label class="form-check-label" for="extra_sAdvice">SMS avízo (len CZ/SK)</label>
			</div>
			
			<div class="form-check">
			<input type="checkbox" class="form-check-input" value="1" name="extra_tAdvice" id="extra_tAdvice"<?= zk123_getConfig('extra_tAdvice') ? ' checked' : ''; ?>>
			<label class="form-check-label" for="extra_tAdvice">Telefonické avízo (len CZ/SK)</label>
			</div>
		</div>
		
		<hr>
		<div class="form-group">
			<label for="label_type">Formát štítkov:</label>
			<select class="form-control" id="label_type" name="label_type">
				<option>A4</option>
				<option<?= zk123_getConfig('label_type') == 'ZEBRA' ? ' selected' : ''; ?>>ZEBRA</option>
				<!-- <option<?= zk123_getConfig('label_type') == 'ZPL' ? ' selected' : ''; ?>>ZPL</option>
				<option<?= zk123_getConfig('label_type') == 'ZPL300' ? ' selected' : ''; ?>>ZPL300</option> -->
			</select>
		</div>
		<hr>
		
		<div class="form-group">
			<label for="default_weight">Predzvolená hmotnosť:</label>
			<div class="input-group">
				<input type="number" class="form-control input-group-prepend" id="default_weight" name="default_weight" value="<?= esc_attr(zk123_getConfig('default_weight')); ?>"><span class="input-group-text input-group-append" >Kg</span>
			</div>
			<small class="form-text text-muted">
				<p>Pre ignoráciu hmotnosti zadajte 0 (hmotnosť potom nebude nutné vyplňovať).</p>
			</small>
		</div>
		<hr>
		
		<div class="form-group">
			<label for="pickup_time_today">Neponúkať zvoz na dnešný deň po čase:</label>
			<div class="input-group">
				<input type="time" class="form-control" id="pickup_time_today" name="pickup_time_today" value="<?= esc_attr(zk123_getConfig('pickup_time_today')) ?: '17:00'; ?>">
			</div>
		</div>
		
		<br><br><br>
		
		<div class="text-right" style="position:sticky;bottom:0;background:linear-gradient(to bottom,rgba(255,255,255,0),rgba(0,0,0,.2));margin:-15px;padding:0 15px 15px 15px;pointer-events:none">
			<button type="submit" class="btn btn-primary shadow-sm" style="pointer-events: all;z-index: 10;position: relative;">Uložiť nastavenie</button>
		</div>
	</form>
	
	<script>
	$('#checkPickup').on('click', function(){
		$('#id_sender').attr('readonly', $(this).is(':checked'));
	}).each(function(){
		var o = $(this);
		if (o.is(':checked')) o.triggerHandler('click');
	});
	
	$('.mytoggl').on('click', function(){
		var o = $(this);
		$('[data-id='+o.attr('id')+']').toggle( o.is(':checked') );	
	}).each(function(){
		var o = $(this);
		if (!o.is(':checked')) o.triggerHandler('click');
	});
	
	setTimeout(function(){
		$('.msgok').parent().slideUp();
	}, 2000);
	
	$('.form-check').click(function(e){
		if ($(e.target).closest('LABEL,INPUT').length) return;
		var inp = $(this).find('INPUT');
		if (inp.length) inp.prop('checked', !inp.prop('checked'));
	});
	</script>
	
	<?php

}
elseif ($_GET['action'] == 'create_pickup')
{
	/*
	//---- OBJEDNÁVKA ZVOZU -- samostatně nepoužívám
	heading('Objednávka zvozu');
	
	exit; // ???????
	$result = zk123_request('atol-api/order/request-pickup', []);
	
	// order_request_pickup objedná zvoz pre zásielky ktoré sú v stave príprava zásielky
	
	print_r($result);
	
	
	exit;
	*/
}
elseif ($_GET['action'] == 'pickuplist')
{
	//--- PODACÍ ARCH
	
	if (!empty($_REQUEST['pickup_date']))
	{
		// chce vytisknout arch podle data podání => najdeme zásilky importované pro daný datum!
		$orders = wc_get_orders( array(
			'limit'        => -1,
			'orderby'      => 'date',
			'order'        => 'DESC',
			'meta_key'     => '_zk123_pickup_date',
			'meta_value' => $_REQUEST['pickup_date']
		));
		
		$post_ids = [];
		foreach ($orders as $post) {
			$post_id = $post->get_id();
			$post_ids[] = $post_id;
		}
	}
	
	
	
	$all_codes = array();
	$dates = array();
	foreach ($post_ids as $post_id)
	{
		$date = get_post_meta($post_id, '_zk123_pickup_date', $single = true);
		$codes = get_post_meta($post_id, '_zk123_tracking_code', $single = true);
		$dates[] = $date;
		
		if (empty($codes)) {
			heading('Podací hárok');
			zk123_error('Objednávka #'.$post_id.' musí byť najskôr importovaná.');
			exit;
		}
		else {
			$all_codes = array_merge($all_codes, explode(";", $codes));
		}
	}
	
	if (count($dates) > 1 && !isset($_REQUEST['pickup_date']))
	{
		// musí vybrat datum
		heading('Podací hárok');
		zk123_chooseDate('Označené zásielky majú rôzne dátumy zvozu.<br> Vyberte dátum zvozu:', $dates);
		exit;
	}
	
	
	try {
		$result = zk123_request('atol-api/order/summary', ["orders" => $all_codes]);
		
		if (!isset($result['pdf'])) throw new Exception('Neznámá chyba');
		
		$pdfContent = base64_decode($result['pdf']);
		
		
		// a ještě objednáme svoz
		// toto objedná svoz pro všechny otevřené zásilky
		$resultPickup = zk123_request('atol-api/order/request-pickup', []);
		
		header("Content-Type: application/pdf");
		header('Content-Disposition: inline; filename="harok_'.date('dmY_Hi', current_time('timestamp')).'.pdf"');
		echo $pdfContent;
		exit;
	}
	catch (Exception $e) {
		heading('Podací hárok');
		zk123_error('API: '.$e->getMessage());
		exit;
	}
	
	heading('Podací hárok');
	zk123_error('Žiadna objednávka na tlač.');
}
elseif ($_GET['action'] == 'labels')
{
	//--- TISK PDF ŠTÍTKŮ
	heading('PDF štítky');
	
	$codes = trim((string) $_REQUEST['codes'], ';');
	$codes = $codes ? explode(";", $codes) : array();
	
	if (empty($codes)) {
		zk123_error('Žiadne zásielky k tlači.');
	}
	else {
		try {
			while(@ob_end_clean());
			
			$result = zk123_request('atol-api/order/ticket', [
				"orders" => $codes,
				"type" => zk123_getConfig('label_type') ?: 'A4', // A4, ZEBRA
				"position" => min(4, max(1, $_REQUEST['pos'])),
			]);
			
			if (!isset($result['pdf'])) throw new Exception('Neznámá chyba');
			
			$pdfContent = base64_decode($result['pdf']);
			header("Content-Type: application/pdf");
			header('Content-Disposition: inline; filename="stitky_'.date('dmY_Hi', current_time('timestamp')).'.pdf"');
			echo $pdfContent;
			exit;
		}
		catch (Exception $e) {
			zk123_error('API: '.$e->getMessage());
		}
	}
	
}
elseif ($_GET['action'] == 'import')
{
	//--- IMPORT BALÍKŮ
	heading('Import balíkov');
	
	
	// IBAN účty
	$ibans = [];
	for ($i=1; $i<=9; $i++) {
		$iban = zk123_getConfig('iban'.($i == 1 ? '' : $i));
		$iban_name = zk123_getConfig('iban_name'.($i == 1 ? '' : $i));
		if (!empty($iban)) {
			if (empty($iban_name)) $iban_name = $i == 1 ? 'Hlavný účet' : 'IBAN č.'.$i;
			$ibans[] = [$iban, $iban_name];
		}
	}
	
	
	if (empty($post_ids))
	{
		zk123_error('Neboli vybrané žiadne objednávky.');
	}
	elseif (empty($_POST['pickup_date']) || !strtotime($_POST['pickup_date']))
	{
		// musí vybrat datum svozu
		zk123_chooseDate('Zvoľte dátum zvozu:');
		exit;
	}
	elseif (count($ibans) > 1 && empty($_POST['iban']))
	{
		// musí vybrat IBAN účet
		zk123_chooseIban('Zvoľte bankový účet pre dobierku:', $ibans);
		exit;
	}
	else
	{
		// datum svozu
		$pickup_date = empty($_POST['pickup_date']) ? date("Y-m-d", current_time('timestamp')) : $_POST['pickup_date'];
		$pickup_date = date("d.m.Y", strtotime($pickup_date));
		
		
		$imported = '';
		$kurierOrders = [];
		
		$rq_post_ids = array_combine($post_ids, $post_ids);
		foreach ($rq_post_ids as $post_id)
		{
			// IMPORT NOVÉ ZÁSILKY
			
			if (!zk123_is($post_id)) {
				// jiný typ dopravy
				continue;
			}
			
			$ord = wc_get_order($post_id);
			
			if (!$ord) continue; // neexistuje
			
			// print_r( get_class_methods($ord) );
			
			$trackingCodes = get_post_meta($post_id, '_zk123_tracking_code', $single = true);
			
			if ($trackingCodes) {
				//-------- už bylo dříve importováno!
				
				// zjistím stav této zásilky
					
				$result = zk123_request('atol-api/order/status', ['orderNumbers' => [ current(explode(";", $trackingCodes)) ] ]);
				$last_info = current($result);
				$status = $last_info['status'];
				if ($status['id'] == 19 || $status['id'] == 21) {
					// čeká / připravená na svoz => nebudu posílat do API
					$imported.= ($imported == '' ? '' : ';').$trackingCodes;
					unset($rq_post_ids[$post_id]); // nebudu posílat znovu do API
					continue;
				}
			}
			
			
			// pokud je v konfiguraci nastaveno číslo, tak je hmotnost nepovinná
			$defaultWeight = zk123_getConfig('default_weight');
			$hasDefaultWeight = true;
			if (!is_numeric($defaultWeight)) {
				$defaultWeight = '0';
				$hasDefaultWeight = false;
			}
			
			$weights = get_post_meta($post_id, '_zk123_packages_weight', $single = true);
			
			// Seznam balíků v zásilce - rozměry nedáváme, hmotnost v kg
			$packages = array();
			$weights = $weights ? explode('+', $weights) : array($defaultWeight);
			foreach ($weights as $weight) {
				if ($weight > 0 || $hasDefaultWeight) {
					$packages[] = array(
						'weight' => (float) str_replace(',', '.', $weight) // hmotnost_kg
					);
				}
			}
			
			
			if (empty($packages)) {
				$withError = true;
				zk123_error('Objednávka #'.$post_id.' preskočená. Nutné doplniť hmotnosť balíka.');
				continue;
			}
			
			// PŘÍJEMCE
			$fullname = trim($ord->get_shipping_first_name().' '.$ord->get_shipping_last_name().' '.$ord->get_shipping_company());
			$street = trim($ord->get_shipping_address_1().' '.$ord->get_shipping_address_2());
			$city = trim($ord->get_shipping_city());
			$zip = trim($ord->get_shipping_postcode());
			$country = trim($ord->get_shipping_country());
			
			if (!$fullname) $fullname = trim($ord->get_billing_first_name().' '.$ord->get_billing_last_name().' '.$ord->get_billing_company());
			if (!$street) $street = trim($ord->get_billing_address_1().' '.$ord->get_billing_address_2());
			if (!$city) $city = trim($ord->get_billing_city());
			if (!$zip) $zip = trim($ord->get_billing_postcode());
			if (!$country) $country = trim($ord->get_billing_country());
			if (!$country) $country = 'SK';
			
			
			
			// poznámka řidiči
			$driver_note = get_post_meta($post_id, '_zk123_driver_note', $single = true);
			
			
			// DOBÍRKA
			$COD = 0;
			if (zk123_isCOD($ord->get_payment_method_title())) {
				// dobírka, měna, variabilní symbol
				// $ord->get_currency() -- měna se považuje za takovou jaká je v dané zemi
				$COD = $ord->get_total();
			}
			
			
			// REFERENCE ZÁSILKY
			$order = new WC_Order($post_id);
			$reference = trim(str_replace('#', '', $order->get_order_number()));
			
			$pickup_on = zk123_getConfig('pickup_on');
			$pickup_name = zk123_getConfig('pickup_name');
			$pickup_street = zk123_getConfig('pickup_street');
			$pickup_zip = zk123_getConfig('pickup_zip');
			$pickup_city = zk123_getConfig('pickup_city');
			$pickup_phone = zk123_getConfig('pickup_phone');
			$pickup_email = zk123_getConfig('pickup_email');
			$pickupAddress = $pickup_on && ($pickup_name || ($pickup_street && $pickup_zip && $pickup_city));
			
			
			$sender_on = zk123_getConfig('sender_on');
			$sender_name = zk123_getConfig('sender_name');
			$sender_street = zk123_getConfig('sender_street');
			$sender_zip = zk123_getConfig('sender_zip');
			$sender_city = zk123_getConfig('sender_city');
			$senderMask = $sender_on && ($sender_name || ($sender_street && $sender_zip && $sender_city));
			if (!$senderMask) {
				$sender_name = $sender_street = $sender_zip = $sender_city = '';
			}
			
			$variable_symbol = $reference;
			if (strlen($variable_symbol) > 10) {
				$variable_symbol = substr($variable_symbol, -10); // posledních 10 číslic
			}
			
			
			$pickup_zip = str_replace(" ", "", $pickup_zip);
			$sender_zip = str_replace(" ", "", $sender_zip);
			
			if ($pickupAddress) {
				// vlastní adresa svozu
				$sender_block = [
					"name" => $pickup_name,
					"street" => $pickup_street,
					"zip" => $pickup_zip,
					"city" => $pickup_city,
					"country" => "Slovensko",
					"phone" => zk123_sanitizePhoneNumber($pickup_phone, 'SK'),
					"contactPerson" => "",
					"mail" => $pickup_email,
				];
			}
			else {
				// ID adresa svozu
				$sender_block = [
					"id" => zk123_getConfig('id_sender')
				];
			}
			
			//---- krycí adresa
			$sender_block['type'] = $senderMask ? 1 : 0; // krycia adresa
			$sender_block['etiket'] = [
				"name" => $sender_name,
				"street" => $sender_street,
				"zip" => $sender_zip,
				"city" => $sender_city,
				"country" => $senderMask ? 'SK' : '', // vždy SK
			];
			
			
			$kurierOrder = array(
	            "clientOrderNumber" => $reference,
	            "dateOfCall" => $pickup_date, // den svozu
	            "cashOnDelivery" => $COD,
	            "cashOnDeliveryVarSymbol" => $variable_symbol,
				'cashOnDeliveryIban' => !empty($_POST['iban']) ? $_POST['iban'] : zk123_getConfig('iban'),
	            "note" => $driver_note,
	            "sender" => $sender_block,
	            "recipient" => [
	                "name" => $fullname,
	                "street" => $street,
	                "zip" => $zip,
	                "city" => $city,
	                "country" => $country,
	                "phone" => zk123_sanitizePhoneNumber($ord->get_billing_phone(), $country),
	                "contactPerson" => "",
	                "mail" => $ord->get_billing_email()
	            ],
	            "items" => $packages,
	            "insurance" => [
	                "enabled" => zk123_getConfig('extra_insurance') ? 1 : 0, // pojištění
	                "orderValue" => $ord->get_total()
	            ],
	            "services" => [
	                "gdd" => zk123_getConfig('extra_gdd', false), // gdd -garantované doručenie 1/0 povolené len pre SK
	                "d12" => zk123_getConfig('extra_d12', false), // d12 -doručenie do 12 H 1/0 povolené len pre SK
	                "sAdvice" => zk123_getConfig('extra_sAdvice', false), // sAdvice - sms avízo povolené 1/0 povolené len pre SK
	                "tAdvice" => zk123_getConfig('extra_tAdvice', true) // tAdvice -telefonické avízo 1/0 povolené len pre SK
	            ]
			);
			
			$code = get_post_meta($post_id, '_zk123_shippingPickup_code', $single = true);
			if (!empty($code)) {
				// vyzvedne na pickup point
				$kurierOrder["services"]["PackageCentre"] = $code;
			}
			
			$kurierOrders[] = $kurierOrder;
		}
		
		try {
			$result = zk123_request('atol-api/order', ['orders' => $kurierOrders]);
		}
		catch (Exception $e) {
			$msg = $e->getMessage();
			zk123_error('Objednávka #'.$post_id.' - '.$msg);
		}
		
		
		// $result['ids'];
		// $result['orderNumbers'];
		
		$i = 0;
		foreach ($rq_post_ids as $post_id) {
			
			// každá zásilka má jedno číslo, bez ohledu na počet balíků!!!!
			
			unset($trackingCode);
			if (!empty($result) && isset($result['orderNumbers']) && isset($result['orderNumbers'][$i])) {
				$trackingCode = $result['orderNumbers'][$i];
			}
			if (empty($trackingCode)) {
				zk123_error("Chyba! Server nevrátil podacie číslo k obj. #$post_id");
				exit;
			}
			
			// uložíme do META TAGU
			update_post_meta($post_id, '_zk123_tracking_code', $trackingCode);
			update_post_meta($post_id, '_zk123_pickup_date', $pickup_date);
			update_post_meta($post_id, '_zk123_pickup_ordered', false);
			update_post_meta($post_id, '_zk123_id', $result['ids'][$i]);
			
			// přidáme k seznamu
			$imported.= ($imported == '' ? '' : ';').$trackingCode;
			
			$i++;
		}
		
		if (empty($imported)) {
			zk123_error('Žiadna objednávka sa neimportovala.');
		}
		else {
			// zobrazíme štítky pro dané balíky
			while(@ob_get_clean());
			header("Location: popup.php?action=labels&codes=".$imported."&pos=".intval(isset($_REQUEST['pos']) ? $_REQUEST['pos'] : 0));
			exit;
		}
	}
}

elseif ($_GET['action'] == 'pickuppoint')
{
	//-------- ZMĚNA POINT POBOČKY U OBJEDNÁVKY
	
	$post_id = intval($_GET['post_id']);
	
	heading('Balíkové Centrum pre obj. #'.$post_id);
	
	if (!empty($_POST))
	{
		// uložíme pobočku
		$code = $_POST['zk123_shippingPickup_code'];
		if (!$_POST['reset'] && !empty($code)) {
			update_post_meta($post_id, '_zk123_shippingPickup_code', $code);
			zk123_ok('Balíkové Centrum zmenené.');
		} else {
			delete_post_meta($post_id, '_zk123_shippingPickup_code');
			zk123_ok('Balíkové Centrum odobrané.');
		}
		$label = zk123_getPickupPointLabel($code);
		
		// aktualizujeme údaj v hlavním okně
		?>
		<script>
		if (window.opener) {
			$(window.opener.document.body).find('#zk123_pobocka_code').html("<?= preg_replace('~(\n|\r|")~', '', $label) ?>");
			window.close();
		}
		</script>
		<?php
	}
	
	
	echo '<script type="text/javascript" charset="UTF-8" data-src="123kurier_pickup.js">';
	echo zk123_handleTemplate(@file_get_contents(__DIR__.'/123kurier_pickup.js'));
	echo '</script>';
	echo '<style data-src="123kurier_pickup.css">';
	echo @file_get_contents(__DIR__.'/123kurier_pickup.css');
	echo '</style>';
	
	?>
	<form method="post">
	<div class="py-2 font-weight-bold">Pickup Point:</div>
	<?php
	$code = get_post_meta($post_id, '_zk123_shippingPickup_code', true);
	$label = zk123_getPickupPointLabel($code);
	?>
	<div id="zk123_shippingPickup_selector"><a href="#zk123_pickup" data-code="<?= $code ?>" data-label="<?= $label ?>"><input type="hidden" name="zk123_shippingPickup_code" value="<?= $code ?>"></a></div>
	
	<div class="text-center pt-3 pb-4">
		<button class="btn btn-primary" name="save" value="1" type="submit">Uložiť</button>
		<?php if (!empty($code)) { ?> &nbsp; <button class="btn btn-danger" name="reset" value="1" type="submit">&times; Zrušiť doručenie na pobočku</button><?php } ?>
	</div>
	</form>
	<?php
}

footer();

